<script lang="ts">
  import { focusItemsStore } from "$lib/local/stores/session.store";
  import Button from "$lib/tidy/elements/button/Button.svelte";
  import TextInput from "$lib/tidy/elements/input/TextInput.svelte";
  import Check from "$lib/tidy/icons/Check.svelte";
  import { Direction } from "$lib/tidy/types/direction.enum";
  import { InputStyle } from "$lib/tidy/types/input.type";
  import { Size } from "$lib/tidy/types/size.enum";
  export let goalId: string | undefined = undefined;
  export let placeholder: string = "+ add a task";
  let label: string = "";
  let inputRef: any;
  export function focus() {
    inputRef.focus();
  }
  async function save() {
    if (!label) return;
    const labelCopy = label;
    reset();
    if (goalId) await focusItemsStore.addTask(labelCopy, goalId);
    else await focusItemsStore.addTask(labelCopy);
  }
  function reset() {
    label = "";
  }
</script>

<div class="flex items-center gap-2 w-full px-4 {goalId ? 'h-12' : 'h-14'}">
  <div class="flex justify-center items-center">
    <Check isChecked={false} />
  </div>
  <TextInput
    on:enter={save}
    on:focus
    on:blur
    bind:value={label}
    bind:this={inputRef}
    style={InputStyle.PLAIN}
    {placeholder}
  />
  <div class=" flex justify-end items-center">
    {#if label}
      <div class="flex gap-2">
        {#if label}
          <Button on:click={save} size={Size.xs} label="⮐ add" />
        {/if}
        <Button
          on:click={reset}
          icon="cross"
          tooltip="Clear"
          toolTipPlacement={Direction.Left}
        />
      </div>
    {/if}
  </div>
</div>
